package com.hungraim.ltc.governance.service.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hungraim.ltc.governance.dao.ChSrvOrganProjectMapper;
import com.hungraim.ltc.governance.dao.DisableLevelMapper;
import com.hungraim.ltc.governance.dao.SrvModeMapper;
import com.hungraim.ltc.governance.service.NursingServiceItemsService;
import com.hungraim.ltc.pojo.entity.SysConfig.ChCfgSrvMode;
import com.hungraim.ltc.pojo.entity.disable.ChCfgSrvDisableLevel;
import com.hungraim.ltc.pojo.entity.serviceManage.ChSrvOrganProject;
import com.hungraim.ltc.pojo.vo.governance.OrganProjectVO;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.Date;
import java.util.List;

@Service
public class NursingServiceItemsServiceImpl implements NursingServiceItemsService {

    @Autowired
    private ChSrvOrganProjectMapper chSrvOrganProjectMapper;
    @Autowired
    private DisableLevelMapper disableLevelMapper;
    @Autowired
    private SrvModeMapper srvModeMapper;

    @Override
    public Page<OrganProjectVO> organProjectList(Page<OrganProjectVO> page, String organIds, String name, String status) {
        List<String> organIdList = null;
        if (StrUtil.isNotBlank(organIds)) {
            organIdList = Arrays.asList(organIds.split(","));
        }
        return chSrvOrganProjectMapper.organProjectList(page, organIdList, name, status);
    }

    @Override
    public void organProjectConfig(ChSrvOrganProject project) {
        if (project.getProjectId() != null) {
            project.setEffTime(new Date());//创建时间
            chSrvOrganProjectMapper.updateById(project);
        } else {
            chSrvOrganProjectMapper.insert(project);
        }
    }

    @Override
    public void disableLevelConfig(String disableLevelId, String disableLevelName, Short disableLevelStartValue, Short disableLevelEndValue, String disableLevelRemark) {
        if (StringUtils.isNotBlank(disableLevelId)) {
            ChCfgSrvDisableLevel chCfgSrvDisableLevel = disableLevelMapper.selectById(disableLevelId);
            chCfgSrvDisableLevel.setDisableLevelName(disableLevelName);
            chCfgSrvDisableLevel.setStartValue(disableLevelStartValue);
            chCfgSrvDisableLevel.setEndValue(disableLevelEndValue);
            chCfgSrvDisableLevel.setRemark(disableLevelRemark);
            disableLevelMapper.updateById(chCfgSrvDisableLevel);
        } else {
            ChCfgSrvDisableLevel chCfgSrvDisableLevel = new ChCfgSrvDisableLevel();
            chCfgSrvDisableLevel.setDisableLevelName(disableLevelName);
            chCfgSrvDisableLevel.setStartValue(disableLevelStartValue);
            chCfgSrvDisableLevel.setEndValue(disableLevelEndValue);
            chCfgSrvDisableLevel.setRemark(disableLevelRemark);
            disableLevelMapper.insert(chCfgSrvDisableLevel);
        }
    }

    @Override
    public void modeConfig(String modeId, String modeName, String modeRemark) {
        if (StringUtils.isNotBlank(modeId)) {
            ChCfgSrvMode chCfgSrvMode = srvModeMapper.selectById(modeId);
            chCfgSrvMode.setModeName(modeName);
            chCfgSrvMode.setRemark(modeRemark);
            srvModeMapper.updateById(chCfgSrvMode);
        } else {
            ChCfgSrvMode chCfgSrvMode = new ChCfgSrvMode();
            chCfgSrvMode.setModeName(modeName);
            chCfgSrvMode.setRemark(modeRemark);
            srvModeMapper.insert(chCfgSrvMode);
        }
    }

    @Override
    public List<ChCfgSrvDisableLevel> disableLevelConfigList() {
        return disableLevelMapper.selectList(new QueryWrapper<>());
    }

    @Override
    public List<ChCfgSrvMode> modeConfigList() {
        return srvModeMapper.selectList(new QueryWrapper<>());
    }

    @Override
    public void delectDisableLevel(Long disableLevelId) {
        disableLevelMapper.deleteById(disableLevelId);
    }

}
